stages:
  - build
  - test
  - deploy
  - task

image: wilson208/circleci-awscli:node
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - ui/node_modules/

build reviewer server:
  stage: build
  image: plantingspace/lambda-rust
  script:
    - cd servers/reviewer
    - cargo build
  only:
    changes:
      - servers/reviewer/src/**/*
  except:
    - schedules

build files server:
  stage: build
  image: plantingspace/lambda-rust
  script:
    - cd servers/file_hoster
    - cargo build
  only:
    changes:
      - servers/file_hoster/**/*
  except:
    - schedules

build ui:
  stage: build
  script:
    - cd ui
    - yarn install
    - yarn generate
  only:
    changes:
      - ui/**/*
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

test ui:
  stage: test
  script:
    - cd ui
    - yarn install
    - yarn run test
  only:
    changes:
      - ui/**/*
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

build blog:
  stage: build
  script:
    - cd blog
    - yarn install
    - yarn build
  only:
    changes:
      - blog/**/*
  except:
    - schedules

build api docs:
  stage: build
  script:
    - cd servers/reviewer/docs
    - yarn install
    - yarn doc
  only:
    changes:
      - servers/reviewer/docs/**/*
  except:
    - schedules

build js lib docs:
  stage: build
  script:
    - cd libraries/mangrove-reviews-js
    - yarn install
    - yarn doc
  only:
    changes:
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

test js lib:
  stage: test
  script:
    - cd libraries/mangrove-reviews-js
    - yarn install
    - yarn test
  only:
    changes:
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

pages:
  stage: deploy
  variables:
    BASE_URL: "https://staging.mangrove.reviews"
  stage: deploy
  script:
    - cd ui
    - yarn install
    - yarn generate
    - cd ..
    - mkdir public
    - cp -r ui/dist/* public
  artifacts:
    paths:
      - public
  except:
    - master
    - schedules
  only:
    changes:
      - ui/**/*

deploy api docs:
  stage: deploy
  variables:
    DOCS_BUCKET: "docs.mangrove.reviews"
    DOCS_DIST: "E2HRIGC1I7B7ZA"
  script:
    - cd servers/reviewer/docs
    - yarn install
    - yarn doc
    - aws s3 rm s3://$DOCS_BUCKET --recursive
    - aws s3 cp --recursive ./dist s3://$DOCS_BUCKET
    - aws cloudfront create-invalidation --distribution-id $DOCS_DIST --paths "/*"
  only:
    refs:
      - master
    changes:
      - servers/reviewer/docs/**/*
  except:
    - schedules

deploy js lib docs:
  stage: deploy
  variables:
    JS_BUCKET: "js.mangrove.reviews"
    JS_DIST: "E3PQ8VOO0YPOZI"
  script:
    - cd libraries/mangrove-reviews-js
    - yarn install
    - yarn doc
    - aws s3 rm s3://$JS_BUCKET --recursive
    - aws s3 cp --recursive ./dist s3://$JS_BUCKET
    - aws cloudfront create-invalidation --distribution-id $JS_DIST --paths "/*"
  only:
    refs:
      - master
    changes:
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

deploy ui:
  stage: deploy
  variables:
    BASE_URL: "https://mangrove.reviews"
    UI_BUCKET: "mangrove.reviews"
    UI_DIST: "E3R6KTTYJH0XRG"
    VUE_APP_API_URL: "https://api.mangrove.reviews"
    VUE_APP_FILES_URL: "https://files.mangrove.reviews"
    VUE_APP_UPLOAD_URL: "https://upload.mangrove.reviews"
  script:
    - cd ui
    - yarn install
    - yarn generate
    - aws s3 rm s3://$UI_BUCKET --recursive
    - aws s3 cp --recursive ./dist s3://$UI_BUCKET
    - aws cloudfront create-invalidation --distribution-id $UI_DIST --paths "/*"
  only:
    refs:
      - master
    changes:
      - ui/**/*
      - libraries/mangrove-reviews-js/**/*
  except:
    - schedules

deploy blog:
  stage: deploy
  variables:
    BLOG_BUCKET: "blog.mangrove.reviews"
    BLOG_DIST: "E2MJJIV6P7ASG5"
  script:
    - cd blog
    - yarn install
    - yarn build
    - aws s3 rm s3://$BLOG_BUCKET --recursive
    - aws s3 cp --recursive ./public s3://$BLOG_BUCKET
    - aws cloudfront create-invalidation --distribution-id $BLOG_DIST --paths "/*"
  only:
    refs:
      - master
    changes:
      - blog/**/*
  except:
    - schedules

aggregator:
  stage: task
  image: julia:latest
  script:
    - cd aggregator
    - julia --project run.jl
  only:
    - schedules

build widget:
  stage: build
  variables:
    WIDGET_APP_API_URL: "https://api.mangrove.reviews"
    WIDGET_APP_UPLOAD_URL: "https://upload.mangrove.reviews"
  script:
    - cd widget
    - yarn install
    - yarn run build
  artifacts:
    paths:
      - dist
  only:
    changes:
      - widget/**/*
  except:
    - schedules

test widget:
  stage: test
  variables:
    WIDGET_APP_API_URL: "https://api.mangrove.reviews"
    WIDGET_APP_UPLOAD_URL: "https://upload.mangrove.reviews"
  script:
    - cd widget
    - yarn install
    - yarn run test
  only:
    changes:
      - widget/**/*
  except:
    - schedules
